diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-phy-cca-test.cc ns-3.47/src/wifi/test/wifi-phy-cca-test.cc
--- ns-3.46/src/wifi/test/wifi-phy-cca-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-phy-cca-test.cc	2026-02-16 16:08:49.882231000 -0800
@@ -3807,8 +3770,8 @@
 {
     m_rxPhy->Dispose();
     m_rxPhy = nullptr;
-    m_txPhy->Dispose();
-    m_txPhy = nullptr;
+    m_uxPhy->Dispose();
+    m_uxPhy = nullptr;
     for (auto& signalGenerator : m_signalGenerators)
     {
         signalGenerator->Dispose();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-phy-mu-mimo-test.cc ns-3.47/src/wifi/test/wifi-phy-mu-mimo-test.cc
--- ns-3.46/src/wifi/test/wifi-phy-mu-mimo-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-phy-mu-mimo-test.cc	2026-02-16 16:08:49.882231000 -0800
@@ -535,7 +535,7 @@
     NS_ASSERT(staInfos.size() > 1);
 
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_MU,
                                          NanoSeconds(800),
                                          1,
@@ -1289,7 +1289,7 @@
     WifiConstPsduMap psdus;
 
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -1324,7 +1324,7 @@
                                                     uint8_t bssColor) const
 {
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_TB,
                                          NanoSeconds(1600),
                                          1,
@@ -1348,7 +1348,7 @@
 TestUlMuMimoPhyTransmission::SetTrigVector(const std::vector<uint16_t>& staIds, uint8_t bssColor)
 {
     WifiTxVector txVector(HePhy::GetHeMcs7(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_HE_TB,
                           NanoSeconds(1600),
                           1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.47/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.46/src/wifi/test/wifi-phy-ofdma-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-phy-ofdma-test.cc	2026-02-16 16:08:49.882231000 -0800
@@ -550,7 +550,7 @@
     WifiConstPsduMap psdus;
     WifiTxVector txVector{
         (m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
-        0,
+        WIFI_MIN_TX_PWR_LEVEL,
         (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_PREAMBLE_HE_MU : WIFI_PREAMBLE_EHT_MU,
         NanoSeconds(800),
         1,
@@ -1598,7 +1598,7 @@
     NS_LOG_FUNCTION(this << rxStaId1 << rxStaId2);
     WifiConstPsduMap psdus;
     WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_HE_MU,
                           NanoSeconds(800),
                           1,
@@ -2298,7 +2298,7 @@
 {
     WifiConstPsduMap psdus;
     WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_HE_MU,
                           NanoSeconds(800),
                           1,
@@ -2350,7 +2350,7 @@
     WifiConstPsduMap psdus2;
 
     WifiTxVector txVector1{HePhy::GetHeMcs7(),
-                           0,
+                           WIFI_MIN_TX_PWR_LEVEL,
                            WIFI_PREAMBLE_HE_TB,
                            NanoSeconds(1600),
                            1,
@@ -2429,7 +2429,7 @@
 {
     WifiConstPsduMap psdus;
     WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_HE_SU,
                           NanoSeconds(800),
                           1,
@@ -2582,7 +2582,7 @@
     : TestCase("UL-OFDMA multiple RX events test"),
       m_totalBytesDropped(0),
       m_trigVector(HePhy::GetHeMcs7(),
-                   0,
+                   WIFI_MIN_TX_PWR_LEVEL,
                    WIFI_PREAMBLE_HE_TB,
                    NanoSeconds(1600),
                    1,
@@ -2647,7 +2647,7 @@
 {
     WifiConstPsduMap psdus;
     WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_HE_TB,
                           NanoSeconds(1600),
                           1,
@@ -3482,7 +3482,7 @@
 
     WifiTxVector txVector{
         (m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
-        0,
+        WIFI_MIN_TX_PWR_LEVEL,
         (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_PREAMBLE_HE_SU : WIFI_PREAMBLE_EHT_MU,
         NanoSeconds(800),
         1,
@@ -3535,7 +3535,7 @@
 {
     WifiTxVector txVector{
         (m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
-        0,
+        WIFI_MIN_TX_PWR_LEVEL,
         (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_PREAMBLE_HE_TB : WIFI_PREAMBLE_EHT_TB,
         NanoSeconds(1600),
         1,
@@ -3619,7 +3619,7 @@
 
     WifiTxVector txVector(
         (m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
-        0,
+        WIFI_MIN_TX_PWR_LEVEL,
         (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_PREAMBLE_HE_TB : WIFI_PREAMBLE_EHT_TB,
         NanoSeconds(1600),
         1,
@@ -5269,7 +5269,7 @@
     WifiConstPsduMap psdus;
 
     WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_HE_TB,
                           NanoSeconds(1600),
                           1,
@@ -5570,7 +5570,7 @@
 TestPhyPaddingExclusion::SetTrigVector(Time ppduDuration)
 {
     WifiTxVector trigVector{HePhy::GetHeMcs7(),
-                            0,
+                            WIFI_MIN_TX_PWR_LEVEL,
                             WIFI_PREAMBLE_HE_TB,
                             NanoSeconds(1600),
                             1,
@@ -5803,7 +5803,7 @@
       m_txPowerAp(dBm_u{0}),
       m_txPowerStart(dBm_u{0}),
       m_txPowerEnd(dBm_u{0}),
-      m_txPowerLevels(0),
+      m_txPowerLevels(1),
       m_requestedRssiSta1(dBm_u{0}),
       m_requestedRssiSta2(dBm_u{0}),
       m_rssiSta1(dBm_u{0}),
@@ -5886,7 +5886,7 @@
 
     WifiConstPsduMap psdus;
     WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_HE_SU,
                           NanoSeconds(800),
                           1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-phy-reception-test.cc ns-3.47/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.46/src/wifi/test/wifi-phy-reception-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-phy-reception-test.cc	2026-02-16 16:08:49.883231000 -0800
@@ -108,7 +108,7 @@
 WifiPhyReceptionTest::SendPacket(dBm_u rxPower, uint32_t packetSize, uint8_t mcs)
 {
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs(mcs),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -2730,7 +2730,7 @@
 TestAmpduReception::SendAmpduWithThreeMpdus(dBm_u rxPower, uint32_t referencePacketSize)
 {
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -4265,7 +4265,7 @@
 TestUnsupportedBandwidthReception::SendPpdu(MHz_u centerFreq, MHz_u bandwidth)
 {
     auto txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                 0,
+                                 WIFI_MIN_TX_PWR_LEVEL,
                                  WIFI_PREAMBLE_HE_SU,
                                  NanoSeconds(800),
                                  1,
@@ -4526,7 +4526,7 @@
     m_txPhy->SetOperatingChannel(
         WifiPhy::ChannelTuple{channelInfo.number, channelInfo.width, channelInfo.band, 0});
     auto txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                 0,
+                                 WIFI_MIN_TX_PWR_LEVEL,
                                  WIFI_PREAMBLE_HE_SU,
                                  NanoSeconds(800),
                                  1,
@@ -4736,7 +4736,7 @@
 TestSpectrumChannelWithBandwidthFilter::Send() const
 {
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -4914,7 +4914,7 @@
 TestPhyDropDueToTx::Send(Ptr<WifiPhy> phy) const
 {
     const auto txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                       0,
+                                       WIFI_MIN_TX_PWR_LEVEL,
                                        WIFI_PREAMBLE_HE_SU,
                                        NanoSeconds(800),
                                        1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-phy-rx-trace-helper-test.cc ns-3.47/src/wifi/test/wifi-phy-rx-trace-helper-test.cc
--- ns-3.46/src/wifi/test/wifi-phy-rx-trace-helper-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-phy-rx-trace-helper-test.cc	2026-02-16 16:08:49.883231000 -0800
@@ -257,7 +257,7 @@
     tx_phy->SetTxPowerEnd(txPower);
 
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -297,7 +297,7 @@
     tx_phy->SetTxPowerEnd(txPower);
 
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -1129,7 +1129,7 @@
     tx_phy->SetTxPowerEnd(txPower);
 
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -1170,7 +1170,7 @@
 
     WifiTxVector txVector =
         WifiTxVector(HePhy::GetHeMcs0(),
-                     0,
+                     WIFI_MIN_TX_PWR_LEVEL,
                      WIFI_PREAMBLE_HE_SU,
                      NanoSeconds(800),
                      1,
@@ -1890,7 +1890,7 @@
     propLoss->SetRss(rxPower);
 
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -1936,7 +1936,7 @@
     propLoss->SetRss(rxPower);
 
     auto txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                 0,
+                                 WIFI_MIN_TX_PWR_LEVEL,
                                  WIFI_PREAMBLE_HE_SU,
                                  NanoSeconds(800),
                                  1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-phy-thresholds-test.cc ns-3.47/src/wifi/test/wifi-phy-thresholds-test.cc
--- ns-3.46/src/wifi/test/wifi-phy-thresholds-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-phy-thresholds-test.cc	2026-02-16 16:08:49.883231000 -0800
@@ -129,7 +129,7 @@
 WifiPhyThresholdsTest::MakeWifiSignal(Watt_u txPower, const WifiPhyOperatingChannel& channel)
 {
     WifiTxVector txVector{OfdmPhy::GetOfdmRate6Mbps(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_LONG,
                           NanoSeconds(800),
                           1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-primary-channels-test.cc ns-3.47/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.46/src/wifi/test/wifi-primary-channels-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-primary-channels-test.cc	2026-02-16 16:08:49.883231000 -0800
@@ -459,7 +459,7 @@
     pkt->AddHeader(trigger);
 
     m_triggerTxVector = WifiTxVector(OfdmPhy::GetOfdmRate6Mbps(),
-                                     0,
+                                     WIFI_MIN_TX_PWR_LEVEL,
                                      WIFI_PREAMBLE_LONG,
                                      NanoSeconds(800),
                                      1,
@@ -768,7 +768,7 @@
     uint8_t bssColor = apDev->GetHeConfiguration()->m_bssColor;
     auto txVector = WifiTxVector(
         (m_standard == WIFI_STANDARD_80211ax) ? HePhy::GetHeMcs8() : EhtPhy::GetEhtMcs8(),
-        0,
+        WIFI_MIN_TX_PWR_LEVEL,
         (m_standard == WIFI_STANDARD_80211ax) ? WIFI_PREAMBLE_HE_SU : WIFI_PREAMBLE_EHT_MU,
         NanoSeconds(800),
         1,
@@ -805,7 +805,7 @@
 
     auto txVector = WifiTxVector(
         (m_standard == WIFI_STANDARD_80211ax) ? HePhy::GetHeMcs8() : EhtPhy::GetEhtMcs8(),
-        0,
+        WIFI_MIN_TX_PWR_LEVEL,
         (m_standard == WIFI_STANDARD_80211ax) ? WIFI_PREAMBLE_HE_MU : WIFI_PREAMBLE_EHT_MU,
         NanoSeconds(800),
         1,
@@ -934,7 +934,7 @@
     uint16_t length = 0;
     WifiTxVector trigVector(
         (m_standard == WIFI_STANDARD_80211ax) ? HePhy::GetHeMcs8() : EhtPhy::GetEhtMcs8(),
-        0,
+        WIFI_MIN_TX_PWR_LEVEL,
         (m_standard == WIFI_STANDARD_80211ax) ? WIFI_PREAMBLE_HE_TB : WIFI_PREAMBLE_EHT_TB,
         NanoSeconds(3200),
         1,
@@ -1002,7 +1002,7 @@
         const auto staId = DynamicCast<StaWifiMac>(staDev->GetMac())->GetAssociationId();
         WifiTxVector txVector(
             (m_standard == WIFI_STANDARD_80211ax) ? HePhy::GetHeMcs8() : EhtPhy::GetEhtMcs8(),
-            0,
+            WIFI_MIN_TX_PWR_LEVEL,
             (m_standard == WIFI_STANDARD_80211ax) ? WIFI_PREAMBLE_HE_TB : WIFI_PREAMBLE_EHT_TB,
             NanoSeconds(3200),
             1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-retransmit-test.cc ns-3.47/src/wifi/test/wifi-retransmit-test.cc
--- ns-3.46/src/wifi/test/wifi-retransmit-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-retransmit-test.cc	2026-02-16 16:08:49.883231000 -0800
@@ -393,7 +393,7 @@
 
     // check width of transmitted frames, except CTS because we do not support yet static/dynamic
     // bandwidth operation
-    const auto expectedWidth = (phyId == 0 ? 80 : 40);
+    const auto expectedWidth = (phyId == 0 ? MHz_u{80} : MHz_u{40});
     if (!hdr.IsCts())
     {
         NS_TEST_EXPECT_MSG_EQ(txVector.GetChannelWidth(),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-test.cc ns-3.47/src/wifi/test/wifi-test.cc
--- ns-3.46/src/wifi/test/wifi-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-test.cc	2026-02-16 16:08:49.884231000 -0800
@@ -3616,7 +3616,7 @@
 {
     uint8_t staId = 1;
     auto txVector = WifiTxVector(HePhy::GetHeMcs(0),
-                                 0,
+                                 WIFI_MIN_TX_PWR_LEVEL,
                                  WIFI_PREAMBLE_HE_MU,
                                  guardInterval,
                                  1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/zigbee/model/zigbee-nwk.cc ns-3.47/src/zigbee/model/zigbee-nwk.cc
--- ns-3.46/src/zigbee/model/zigbee-nwk.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/zigbee/model/zigbee-nwk.cc	2026-02-16 16:08:49.887231000 -0800
@@ -677,7 +677,7 @@
                     }
                 }
 
-                Ptr<PendingTxPkt> pendingTxPkt = Create<PendingTxPkt>();
+                auto pendingTxPkt = std::make_shared<PendingTxPkt>();
                 if (!m_pendingTxQueue.empty() &&
                     DequeuePendingTx(payload.GetRespAddr(), pendingTxPkt))
                 {
@@ -1232,7 +1232,7 @@
 void
 ZigbeeNwk::McpsDataConfirm(McpsDataConfirmParams params)
 {
-    Ptr<TxPkt> bufferedElement;
+    std::shared_ptr<TxPkt> bufferedElement;
     if (RetrieveTxPkt(params.m_msduHandle, bufferedElement))
     {
         ZigbeeNwkHeader nwkHeader;
@@ -3004,7 +3004,7 @@
         ZigbeeNwkHeader peekedNwkHeader;
         p->PeekHeader(peekedNwkHeader);
 
-        Ptr<PendingTxPkt> pendingTxPkt = Create<PendingTxPkt>();
+        auto pendingTxPkt = std::make_shared<PendingTxPkt>();
         pendingTxPkt->dstAddr = peekedNwkHeader.GetDstAddr();
         pendingTxPkt->nsduHandle = nsduHandle;
         pendingTxPkt->txPkt = p;
@@ -3019,7 +3019,7 @@
 }
 
 bool
-ZigbeeNwk::DequeuePendingTx(Mac16Address dst, Ptr<PendingTxPkt> entry)
+ZigbeeNwk::DequeuePendingTx(Mac16Address dst, std::shared_ptr<PendingTxPkt> entry)
 {
     // TODO : PurgeTxQueue();
 
@@ -3055,7 +3055,7 @@
 {
     if (m_txBuffer.size() < m_txBufferMaxSize)
     {
-        Ptr<TxPkt> txPkt = Create<TxPkt>();
+        auto txPkt = std::make_shared<TxPkt>();
         txPkt->macHandle = macHandle;
         txPkt->nwkHandle = nwkHandle;
         txPkt->txPkt = p;
@@ -3069,16 +3069,17 @@
 }
 
 bool
-ZigbeeNwk::RetrieveTxPkt(uint8_t macHandle, Ptr<TxPkt>& txPkt)
+ZigbeeNwk::RetrieveTxPkt(uint8_t macHandle, std::shared_ptr<TxPkt>& txPkt)
 {
-    for (auto bufferedPkt : m_txBuffer)
+    for (const auto& bufferedPkt : m_txBuffer)
     {
         if (bufferedPkt->macHandle == macHandle)
         {
             txPkt = bufferedPkt;
 
-            std::erase_if(m_txBuffer,
-                          [&macHandle](Ptr<TxPkt> pkt) { return pkt->macHandle == macHandle; });
+            std::erase_if(m_txBuffer, [&macHandle](std::shared_ptr<TxPkt> pkt) {
+                return pkt->macHandle == macHandle;
+            });
 
             return true;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/zigbee/model/zigbee-nwk.h ns-3.47/src/zigbee/model/zigbee-nwk.h
--- ns-3.46/src/zigbee/model/zigbee-nwk.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/zigbee/model/zigbee-nwk.h	2026-02-16 16:08:49.887231000 -0800
@@ -1057,7 +1057,7 @@
     /**
      * Structure representing an element in the pending transaction queue.
      */
-    struct PendingTxPkt : public SimpleRefCount<PendingTxPkt>
+    struct PendingTxPkt
     {
         uint8_t nsduHandle;   //!< The NSDU handle
         Mac16Address dstAddr; //!< The destination network Address
@@ -1069,7 +1069,7 @@
      * The pending transaction queue of data packets awaiting to be transmitted
      * until a route to the destination becomes available.
      */
-    std::deque<Ptr<PendingTxPkt>> m_pendingTxQueue;
+    std::deque<std::shared_ptr<PendingTxPkt>> m_pendingTxQueue;
 
     /**
      * The maximum size of the pending transaction queue.
@@ -1079,7 +1079,7 @@
     /**
      * Structure representing an element in the Tx Buffer.
      */
-    struct TxPkt : public SimpleRefCount<TxPkt>
+    struct TxPkt
     {
         uint8_t macHandle; //!< The mac handle (msdu handle).
         uint8_t nwkHandle; //!< The nwk handle (nsdu handle).
@@ -1090,7 +1090,7 @@
      * The transmission buffer. Copies of DATA packets are stored here
      * for post transmission handling.
      */
-    std::deque<Ptr<TxPkt>> m_txBuffer;
+    std::deque<std::shared_ptr<TxPkt>> m_txBuffer;
 
     /**
      * The maximum size of the transmission buffer
@@ -1293,7 +1293,7 @@
      *
      * @return True if successfully dequeued
      */
-    bool DequeuePendingTx(Mac16Address dst, Ptr<PendingTxPkt> entry);
+    bool DequeuePendingTx(Mac16Address dst, std::shared_ptr<PendingTxPkt> entry);
 
     /**
      * Dispose of all PendingTxPkt accumulated in the pending transmission queue.
@@ -1320,7 +1320,7 @@
      * @param txPkt The packet buffered in the TxPkt buffer.
      * @return True if the txPkt is successfully retrieved.
      */
-    bool RetrieveTxPkt(uint8_t macHandle, Ptr<TxPkt>& txPkt);
+    bool RetrieveTxPkt(uint8_t macHandle, std::shared_ptr<TxPkt>& txPkt);
 
     /**
      * Dispose of all the entries in the TxPkt Buffer.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/test.py ns-3.47/test.py
--- ns-3.46/test.py	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/test.py	2026-02-16 16:08:49.887231000 -0800
@@ -220,6 +220,9 @@
         # Add all of the C++ examples that were built, i.e. found
         # in the directory, to the list of C++ examples to run.
         if os.path.exists(example_path):
+            # Handle paths with empty spaces
+            example_path = '"%s"' % example_path
+
             # Add any arguments to the path.
             if len(example_name_parts) != 1:
                 example_path = "%s %s" % (example_path, example_arguments)
@@ -322,7 +325,7 @@
 # expected that this output will be fine for developers looking for problems.
 #
 def node_to_text(test, f, test_type="Suite"):
-    (result, name, reason, time_real) = read_test(test)
+    result, name, reason, time_real = read_test(test)
     if reason:
         reason = " (%s)" % reason
 
@@ -390,7 +393,7 @@
             #
             # For each test suite, get its name, result and execution time info
             #
-            (result, name, reason, time) = read_test(suite)
+            result, name, reason, time = read_test(suite)
 
             #
             # Print a level three header with the result, name and time.  If the
@@ -470,7 +473,7 @@
                 # Get the name, result and timing information from xml to use in
                 # printing table below.
                 #
-                (result, name, reason, time) = read_test(case)
+                result, name, reason, time = read_test(case)
 
                 #
                 # If the test case failed, we iterate through possibly multiple
@@ -583,7 +586,7 @@
             #
             # Get the result and name of the example in question
             #
-            (result, name, reason, time) = read_test(example)
+            result, name, reason, time = read_test(example)
 
             #
             # If the example either failed or crashed, print its result status
@@ -867,15 +870,26 @@
     if is_python:
         path_cmd = PYTHON[0] + " " + os.path.join(NS3_BASEDIR, shell_command)
     else:
+
+        # Here we handle paths with empty spaces.
+        # To do that, we need to separate program from arguments, then quote the absolute program path with spaces.
+        shell_args = re.findall(r'(?:".*?"|\S)+', shell_command)
+
         if len(build_path):
-            path_cmd = os.path.join(build_path, shell_command)
+            path_cmd = os.path.join(build_path, shell_args[0])
         else:
-            path_cmd = os.path.join(NS3_BUILDDIR, shell_command)
+            path_cmd = (
+                shell_args[0].strip('"')
+                if NS3_BUILDDIR in shell_args[0]
+                else os.path.join(NS3_BUILDDIR, shell_args[0])
+            )
+
+        path_cmd = f'"{path_cmd}" {" ".join(shell_args[1:])}'
 
     if valgrind:
         if VALGRIND_SUPPRESSIONS_FILE:
             cmd = (
-                "valgrind --suppressions=%s --leak-check=full --show-reachable=yes --error-exitcode=2 --errors-for-leak-kinds=all %s"
+                'valgrind --suppressions="%s" --leak-check=full --show-reachable=yes --error-exitcode=2 --errors-for-leak-kinds=all %s'
                 % (suppressions_path, path_cmd)
             )
         else:
@@ -1193,7 +1207,7 @@
         exit(-1)
 
     for test_type in ["Test", "Example"]:
-        if previous_run_results.find(test_type):
+        if previous_run_results.find(test_type) is not None:
             temp = list(
                 map(
                     lambda x: (x.find("Name").text, x.find("Result").text),
@@ -1372,7 +1386,7 @@
     #
     if args.kinds:
         path_cmd = os.path.join("utils", test_runner_name + " --print-test-type-list")
-        (rc, standard_out, standard_err, et) = run_job_synchronously(
+        rc, standard_out, standard_err, et = run_job_synchronously(
             path_cmd, os.getcwd(), False, False
         )
         print(standard_out)
@@ -1390,7 +1404,7 @@
                 path_cmd = os.path.join(
                     "utils", test_runner_name + " --print-test-name-list --print-test-types"
                 )
-            (rc, standard_out, standard_err, et) = run_job_synchronously(
+            rc, standard_out, standard_err, et = run_job_synchronously(
                 path_cmd, os.getcwd(), False, False
             )
             if rc != 0:
@@ -1508,7 +1522,7 @@
     if len(args.suite):
         # See if this is a valid test suite.
         path_cmd = os.path.join("utils", test_runner_name + " --print-test-name-list")
-        (rc, suites, standard_err, et) = run_job_synchronously(path_cmd, os.getcwd(), False, False)
+        rc, suites, standard_err, et = run_job_synchronously(path_cmd, os.getcwd(), False, False)
 
         if isinstance(suites, bytes):
             suites = suites.decode()
@@ -1533,12 +1547,12 @@
                 "utils",
                 test_runner_name + " --print-test-name-list --test-type=%s" % args.constrain,
             )
-            (rc, suites, standard_err, et) = run_job_synchronously(
+            rc, suites, standard_err, et = run_job_synchronously(
                 path_cmd, os.getcwd(), False, False
             )
         else:
             path_cmd = os.path.join("utils", test_runner_name + " --print-test-name-list")
-            (rc, suites, standard_err, et) = run_job_synchronously(
+            rc, suites, standard_err, et = run_job_synchronously(
                 path_cmd, os.getcwd(), False, False
             )
     else:
@@ -1566,7 +1580,7 @@
         path_cmd = os.path.join(
             "utils", test_runner_name + " --print-test-name-list --test-type=%s" % "performance"
         )
-        (rc, performance_tests, standard_err, et) = run_job_synchronously(
+        rc, performance_tests, standard_err, et = run_job_synchronously(
             path_cmd, os.getcwd(), False, False
         )
         if isinstance(performance_tests, bytes):
@@ -1762,7 +1776,7 @@
 
                 for name, test, do_run, do_valgrind_run, fullness in example_tests:
                     # Remove any arguments and directory names from test.
-                    test_name = test.split(" ", 1)[0]
+                    test_name = re.findall(r'(?:".*?"|\S)+', test)[0].strip('"')
                     test_name = os.path.basename(test_name)
                     test_name = test_name[:-4] if sys.platform == "win32" else test_name
 
@@ -2233,7 +2247,7 @@
     # directories, which will probably surprise the user.
     #
     if not args.retain:
-        shutil.rmtree(testpy_output_dir)
+        shutil.rmtree(TMP_OUTPUT_DIR)
 
     if passed_tests + skipped_tests == total_tests:
         return 0  # success
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/utils/check-style-clang-format.py ns-3.47/utils/check-style-clang-format.py
--- ns-3.46/utils/check-style-clang-format.py	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/utils/check-style-clang-format.py	2026-02-16 16:08:49.888231000 -0800
@@ -659,7 +659,7 @@
                 continue
 
         # Check if the line is compliant with the style and fix it
-        (is_line_compliant, line_fixed, line_verbose_infos) = check_style_line_function(
+        is_line_compliant, line_fixed, line_verbose_infos = check_style_line_function(
             line, filename, i
         )
 
@@ -850,7 +850,9 @@
     ]
     # fmt: on
 
+    # REUSE-IgnoreStart
     SPDX_LICENSE = "SPDX-License-Identifier: GPL-2.0-only"
+    # REUSE-IgnoreEnd
 
     is_line_compliant = True
     line_fixed = line
